<%-- $Id: edit_category.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg, Dominic Oyeniran

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Dominic
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ANNOTATIONTYPECATEGORY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	AnnotationTypeCategory annotationTypeCategory = null;

	
	if (itemId == 0)
	{
		//to create a new annotation category
		title = "Create annotation type category";
		cc.removeObject("item");
	}
	else
	{
		//if user click on edit, to edit annotationcategory
		annotationTypeCategory = AnnotationTypeCategory.getById(dc, itemId);
		cc.setObject("item", annotationTypeCategory);
		title = "Edit annotation type category-- " + HTML.encodeTags(annotationTypeCategory.getName());
		annotationTypeCategory.checkPermission(Permission.WRITE);
	}
	
	// ---- Query to retrieve annotationtype members for a category
	ItemQuery<AnnotationType> annotationTypeQuery = null;
	if (annotationTypeCategory != null)
	{
		annotationTypeQuery = annotationTypeCategory.getAnnotationTypes(null);
		annotationTypeQuery.include(Include.ALL);
		annotationTypeQuery.order(Orders.asc(Hql.property("name")));
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Annotation type category" tab
		function validateAnnotationTypeCategory()
		{
			var frm = document.forms['annotationTypeCategory'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		
		// Validate the "Members" tab
		function validateMembers()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['annotationTypeCategory'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.addAnnotationTypes.value = Link.getActionIds(1, 'Z').join(',');
				frm.removeAnnotationTypes.value = Link.getActionIds(-1, 'Z').join(',');				
				frm.submit();
			}
		}
		// Initialise edit_category web interface		
		
		function init()
		{
			<%
			if (annotationTypeCategory == null)
			{
				%>
				var frm = document.forms['annotationTypeCategory'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initMembers();
		}
		
		function initMembers()
		{
			var members = document.forms['annotationTypeCategory'].members;
			<%
			if (annotationTypeQuery != null)
			{
				ItemResultList<AnnotationType> annotationTypes = annotationTypeQuery.list(dc);
				for (AnnotationType annotationType : annotationTypes)
				{
					%>
					Link.addNewItem(members, new Item('Z', <%=annotationType.getId()%>, '<%=HTML.javaScriptEncode(annotationType.getName())%>'));
					<%
				}
			}
			%>
		}
		function addAnnotationTypesOnClick()
		{
			var annotationtypes = Link.getListIds(document.forms['annotationTypeCategory'].members, 'Z');
			var url = '../annotationtypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addAnnotationTypeCallback';
			url += '&exclude='+annotationtypes.join(',');
			Main.openPopup(url, 'AddAnnotationTypes', 1000, 700);
		}
		
		function addAnnotationTypeCallback(annotationTypeId, name)
		{
			var item = Link.getItem('Z', annotationTypeId);
			if (!item) item = new Item('Z', annotationTypeId, name);
			Link.addItem(document.forms['annotationTypeCategory'].members, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['annotationTypeCategory'].members);
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="annotationTypeCategory" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*280)+"px;"%>" position="bottom">
		<t:tab id="info" title="Annotation type category" validate="validateAnnotationTypeCategory()"
			helpid="annotationtypecategory.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(annotationTypeCategory == null ? Values.getString(cc.getPropertyValue("name"), "New annotation type category") : annotationTypeCategory.getName())%>" 
					size="40" maxlength="<%=AnnotationTypeCategory.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(annotationTypeCategory == null ? cc.getPropertyValue("description") : annotationTypeCategory.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'annotationTypeCategory', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="members" title="Annotation types" tooltip="Add/remove members of this category" 
			validate="validateMembers()" helpid="annotationtypecategory.edit.members">
		<table >
		<tr valign="top">
		<td>
			<b>Annotation types</b><br>
			<select name="members" size="14" multiple 
				style="width: 15em;">
			</select>
			<input type="hidden" name="removeAnnotationTypes" value="">
			<input type="hidden" name="addAnnotationTypes" value="">
		</td>
		<td>
			<br>
			<table width="150">
			<tr><td><base:button 
				onclick="addAnnotationTypesOnClick()" 
				title="Add&nbsp;annotation&nbsp;types&hellip;" 
				tooltip="Add annotation types to this category"
				/></td></tr>
			<tr><td><base:button 
				onclick="removeOnClick()" 
				title="Remove" 
				tooltip="Remove the selected items from this category"
			/></td></tr>
			</table>
		</td>
		</tr>
		</table>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
