<%-- $Id: progress_reporter.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	Display a progress reporter

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SimpleProgressReporter"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%
	String title = Values.getString(request.getParameter("title"));
	String progressName = request.getParameter("progress");
	SessionControl sc = Base.getExistingSessionControl(pageContext, true);
	
	SimpleProgressReporter progress = (SimpleProgressReporter)sc.getSessionSetting("progress." + progressName);
	String message = "";
	int percentDone = 0;
	if (progress != null)
	{
		message = progress.getMessage();
		percentDone = progress.getPercent();
	}
	else
	{
		message = "Please wait...";
	}
	String onload = "";
	if (percentDone >= 100)
	{
		onload = "setTimeout('window.close()', 1500)";
		sc.setSessionSetting("progress." + progressName, null);
	}
	else
	{
		onload = "setTimeout('location.reload()', 1500)";
	}
	
%>
<base:page type="popup" title="<%=title%>">
<base:head styles="progressbar.css">
	<script>
	</script>
</base:head>
<base:body onload="<%=onload%>">

	<div id="progress">
		<h3 class="docked"><%=title%></h3>
		<div class="boxed" style="background: #E0E0E0">
			<br>
			<table width="90%" border=0 cellspacing=0 cellpadding=0 align="center">
			<tr>
			<td width="90%" >
				<table width="100%" class="progressbar" border=0 cellspacing=0 cellpadding=0>
				<tr>
					<td width="<%=percentDone%>%" class="done" id="percentDone">&nbsp;</td>
					<td width="<%=100-percentDone%>%" class="remain" id="percentRemain">&nbsp;</td>
				</tr>
				</table>
			</td>
				<td width="10%" id="percent">&nbsp;<%=percentDone%>%</td>
			</tr>
			<tr><td colspan="2"><%=message%></td></tr>
			</table>
			<br>
		</div>
		<br>
		<table align="center">
		<tr>
			<td><base:button onclick="window.close()" title="Close" /></td>
		</tr>
		</table>
		<div align="center">
		<i>Closing this window will NOT abort the process</i>
		</div>
	</div>

</base:body>
</base:page>
