/* $Id: annotations.js 2584 2006-08-24 07:58:05Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	JavaScript functions for sending Ajax request. Create a
	request with Main.getAjaxRequest() or Ajax.getXmlHttpRequest().

	@author Nicklas
	@version 2.0
*/

var Ajax = new AjaxClass();
function AjaxClass()
{
	/**
		Create a new ajax request.
		@return A request object or null if the browser doesn't support ajax
	*/
	this.getXmlHttpRequest = function()
	{
		return Main.getAjaxRequest();
	}
	
	/**
		Register callback functions for a successful of failed request.
		When the request has been completed, the onSuccessHandler or
		onFailHandler will be called with the request as a parameter:
		onSuccessHandler(request);
	*/
	this.setReadyStateHandler = function(request, onSuccessHandler, onFailHandler)
	{
		request.onreadystatechange = function()
		{
			if (request.readyState == 4)
			{
				if (request.status == 200 && onSuccessHandler)
				{
					onSuccessHandler(request);
				}
				else if (onFailHandler)
				{
					onFailHandler(request);
				}
			}
		}
	}
	
}
