<%-- $Id: edit_event.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.HardwareType"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateEvent"
	import="net.sf.basedb.core.PlateEventType"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATEEVENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int plateId = Values.getInt(request.getParameter("plate_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PlateEvent event = null;
	Plate plate = null;
	PlateEventType eventType = null;
	Date eventDate = null;

	Protocol currentProtocol = null;
	boolean readCurrentProtocol = true;
	ProtocolType currentProtocolType = null;
	boolean readCurrentProtocolType = true;
	Hardware currentHardware = null;
	boolean readCurrentHardware = true;

	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL);
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE);

	ItemResultList<PlateEventType> eventTypes = null;
	if (itemId == 0)
	{
		title = "Create event";
		cc.removeObject("item");
		
		plate = Plate.getById(dc, plateId);
		ItemQuery<PlateEventType> eventTypesQuery = plate.getPlateType().getEventTypes();
		eventTypesQuery.order(Orders.asc(Hql.property("ordinal")));
		eventTypesQuery.join(Hql.leftJoin(null, "plateEvents", "event", 
			Restrictions.eq(Hql.property("event", "plate.id"), Expressions.integer(plate.getId())), false));
		eventTypesQuery.restrict(Restrictions.eq(Hql.alias("event"), null));
		eventTypes = eventTypesQuery.list(dc);
		if (eventTypes.size() == 0)
		{
			throw new WebException("popup", "No more event types can be created", 
				"One event of each event type has already been created for this plate.");
		}		
		
		if (cc.getPropertyFilter("protocolType.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("protocol.name"));
		}
		
		eventDate = (Date)cc.getPropertyObject("eventDate");
	}
	else
	{
		event = PlateEvent.getById(dc, itemId);
		eventType = event.getPlateEventType();
		eventDate = event.getEventDate();
		cc.setObject("item", event);
		title = "Edit event  -- " + HTML.encodeTags(eventType.getName());
		try
		{
			currentProtocol = event.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentProtocolType = eventType.getProtocolType();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocolType = false;
		}
		try
		{
			currentHardware = event.getHardware();
		}
		catch(PermissionDeniedException ex)
		{
			readCurrentHardware = false;
		}
	}
	
	if (event != null && !event.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Event" tab
		function validateEvent()
		{
			var frm = document.forms['event'];
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['event'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		var protocolTypeFilter = <%=currentProtocolType != null ? currentProtocolType.getId() : 0%>;		
		function selectProtocolOnClick()
		{
			var frm = document.forms['event'];
			var url = '../../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			if (protocolTypeFilter)
			{
				url += '&filter:INT:protocolType='+protocolTypeFilter;
			}
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['event'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		function selectHardwareOnClick()
		{
			var frm = document.forms['event'];
			var url = '../../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setHardwareCallback';
			if (frm.hardware_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.hardware_id[1].value));
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectHardware', 1000, 700);
		}
		function setHardwareCallback(id, name)
		{
			var frm = document.forms['event'];
			var list = frm.hardware_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}

		function init()
		{
			var frm = document.forms['event'];
			plateEventTypeOnChange();
		}
		<%
		if (event == null)
		{
			%>
			var protocolTypes = new Array();
			<%
			for (PlateEventType pet : eventTypes)
			{
				try
				{
					ProtocolType pt = pet.getProtocolType();
					if (pt != null)
					{
						%>
						protocolTypes['P<%=pet.getId()%>'] = <%=pt.getId()%>;
						<%
					}
				}
				catch (Throwable t)
				{}
			}
		}
		%>
		function plateEventTypeOnChange()
		{
			var frm = document.forms['event'];
			if (frm.plateeventtype_id)
			{
				var eventTypeId = frm.plateeventtype_id[frm.plateeventtype_id.selectedIndex].value;
				protocolTypeFilter = protocolTypes['P'+eventTypeId];
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="event" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="plate_id" value="<%=plateId%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*250)+"px;"%>" 
			position="bottom" remember="<%=event != null%>">
		<t:tab id="info" title="Event" validate="validateEvent()" helpid="plateevent.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Event type</td>
				<td>
					<%
					if (event == null)
					{
						%>
						<select name="plateeventtype_id" class="required" onchange="plateEventTypeOnChange()">
						<%
						for (PlateEventType pet : eventTypes)
						{
							%>
							<option value="<%=pet.getId()%>"><%=pet.getOrdinal()%>. <%=HTML.encodeTags(pet.getName())%>
							<%
						}
						%>
						</select>
						<%
					}
					else
					{
						%>
						<%=eventType.getOrdinal()%>. <%=HTML.encodeTags(eventType.getName())%>
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Event date</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input <%=clazz%> type="text" name="event_date" 
							value="<%=dateFormatter.format(eventDate == null ? new Date() : eventDate)%>" 
							size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						&nbsp;
					</td>
					<td>
					<base:button 
						onclick="<%="Dates.selectDate('Date', 'event', 'event_date', null, '"+jsDateFormat+"')"%>" 
						image="calendar.png"
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
					/>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Entry date</td>
				<td><%=dateFormatter.format(event == null ? new Date() : event.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						newitem="<%=event == null%>"
						onselect="selectProtocolOnClick()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Hardware</td>
				<td>
					<base:select 
						id="hardware_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentHardware%>"
						denied="<%=!readCurrentHardware%>"
						recent="<%=recentHardware%>"
						newitem="<%=event == null%>"
						onselect="selectHardwareOnClick()"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Comment</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" 
						name="comment" wrap="virtual"><%=HTML.encodeTags(event == null ? cc.getPropertyValue("comment") : event.getComment())%></textarea>
					<a href="javascript:Main.zoom('Comment', 'event', 'comment')" title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
