<%-- $Id: overview.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
	private static final Item itemType = Item.EXPERIMENT;
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final DbControl dc = sc.newDbControl();
try
{
	Experiment experiment = Experiment.getById(dc, itemId);
	%>
	<base:page title="">
	<base:head scripts="tabcontrol.js" styles="toolbar.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		var timer = 0;
		var inCall = false;
		function adjustIFrameSize()
		{
			if (inCall) return;
			inCall = true;
			var iframeElement = document.getElementById("idOverview");
			// Find the top coordinate of the IFrame
			var offsetTop = 10;
			var offsetTrail = iframeElement;
			while (offsetTrail)
			{
				offsetTop += offsetTrail.offsetTop;
				offsetTrail = offsetTrail.offsetParent;
			}
	
			// Find the browser window height
			var windowHeight = Main.getWindowHeight();
			iframeElement.height = windowHeight-offsetTop;
	
			// Adjust the height of the frames
			var iframe = window.frames['overview'];
			var tree = iframe.frames['tree'].document.getElementById('main');
			if (tree) tree.style.height = (iframeElement.height-8)+'px';
			var joust = iframe.frames['tree'].document.getElementById('joust');
			if (joust) joust.style.height = (iframeElement.height-8)+'px';
			var info = iframe.frames['info'].document.getElementById('main');
			if (info) info.style.height = iframeElement.height+'px';
			inCall = false;
		}
		function setTimer()
		{
			if (inCall) return;
			if (timer) clearTimeout(timer);
			timer = setTimeout('adjustIFrameSize()', 150);
		}
		function viewExperimentProperties()
		{
			location.href = '../index.jsp?ID=<%=ID%>&item_id=<%=itemId%>&cmd=ViewItem';
		}
		function viewBioAssaySets()
		{
			location.href = '../bioassaysets/index.jsp?ID=<%=ID%>&experiment_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties')
			{
				viewExperimentProperties();
			}
			else if (tabId == 'bioassaysets')
			{
				viewBioAssaySets();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		
		function expandAll()
		{
			frames['overview']['tree'].openAll();
		}
		function collapseAll()
		{
			frames['overview']['tree'].closeAll();
		}
		function revalidate()
		{
			location.href = 'index.jsp?ID=<%=ID%>&cmd=Overview&revalidate=1';
		}
		function validationOptions()
		{
			Main.openPopup('options.jsp?ID=<%=ID%>', 'ValidationOptions', 700, 500);
		}
		</script>
	</base:head>
	<base:body attributes="onresize='setTimer();'">
		<p>
		<p:path>
			<p:pathelement title="Experiments" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" />
		</p:path>
	
		<t:tabcontrol id="main" active="overview" switch="switchTab">
		<t:tab id="properties" title="Properties" />
		<t:tab id="bioassaysets" title="Bioassay sets" />
		<t:tab id="overview" title="Overview">
		
			<tbl:toolbar>
				<tbl:button image="joust/plusonly.gif" title="Expand all"
					onclick="expandAll()" tooltip="Expand entire tree"/>
				<tbl:button image="joust/minusonly.gif" title="Collapse all" 
					onclick="collapseAll()" tooltip="Collapse entire tree" />
				<tbl:button image="refresh.gif" title="Revalidate" 
					onclick="revalidate()" tooltip="Revalidate the experiment" />
				<tbl:button image="configure.png" title="Validation options&hellip;" 
					onclick="validationOptions()" tooltip="Change validation options" />
				<tbl:button image="help.gif" title="Help&hellip;"
					onclick="<%="Main.openHelp('" + ID +"', 'experiment.overview')"%>"
					tooltip="Get help about this page"
				/>	
			</tbl:toolbar>
			<iframe name="overview" id="idOverview" src="frameset.jsp?ID=<%=ID%>" width="100%" 
				frameborder="0" vspace="0" hspace="0"
				marginwidth="0" marginheight="0" scrolling="no" 
				style="border: 1px solid #999999; border-top: 0px; overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
