<%-- $Id: list_rawbioassays.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.Affymetrix"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
	private static final Item itemType = Item.RAWBIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final String root = request.getContextPath()+"/";
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final boolean readPermission = sc.hasPermission(Permission.READ, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("raw bioassay", "raw bioassays");
final DbControl dc = sc.newDbControl();
ItemResultIterator<RawBioAssay> rawBioAssays = null;
ItemResultList<AnnotationType> annotationTypes = null;
try
{
	final ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);

	// Query for experiments relatated to the current raw bioassay
	final ItemQuery<Experiment> experimentQuery = Experiment.getQuery();
	experimentQuery.include(cc.getInclude());
	experimentQuery.join(Hql.innerJoin("rawBioAssays", "rba"));
	experimentQuery.restrict(Restrictions.eq(Hql.alias("rba"), Expressions.parameter("rawBioAssay")));
	experimentQuery.order(Orders.asc(Hql.property("name"))); 
	
	// Get all platforms
	final ItemQuery<Platform> platformQuery = Platform.getQuery();
	platformQuery.include(cc.getInclude());
	platformQuery.order(Orders.asc(Hql.property("name")));
	platformQuery.setCacheResult(true);
	Enumeration<String, String> platforms = new Enumeration<String, String>();
	for (Platform p : platformQuery.list(dc))
	{
		platforms.add(Integer.toString(p.getId()), p.getName());
	}
	
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	annotationTypes = annotationTypeQuery.list(dc);
	try
	{
		final ItemQuery<RawBioAssay> query = Base.getConfiguredQuery(cc, true, RawBioAssay.getQuery(), mode);
		rawBioAssays = query.iterate(dc);
	}
	catch (Throwable t)
	{
		t.printStackTrace();
		cc.setMessage(t.getMessage());
	}
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	int numListed = 0;
	%>
	<base:page title="<%=title==null ? "Raw bioassays" : title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="menu.js,table.js" styles="menu.css,table.css">
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'rawbioassays';
		function newItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', 0, true);
		}
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem, returnSelected);
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function deleteItemPermanently(itemId)
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', itemId);
		}
		function takeOwnership()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			if (confirm('Are you sure that you want to take ownership of the selected items? It can\'t be undone.'))
			{
				frm.action = submitPage;
				frm.cmd.value = 'TakeOwnershipOfItems';
				frm.submit();
			}
		}
		function shareItem(itemId)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id='+itemId, 'ShareRawBioAssay', 600, 400);
		}
		function shareItems()
		{
			Table.shareItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'ShareItems');
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 740, 540);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function newExperiment()
		{
			var frm = document.forms[formId];
			var selected = Table.getSelected(formId);
			if (selected.length == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			var extraUrl = '&rawbioassay_id='+selected.join('&rawbioassay_id=');
			Main.viewOrEditItem('<%=ID%>', 'EXPERIMENT', 0, true, extraUrl);
		}
		</script>
	</base:head>
	
	<base:body>
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="rawbioassays" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id" 
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="platform"
				property="platform"
				sortproperty="platform.name"
				exportproperty="platform.name"
				datatype="int"
				enumeration="<%=platforms%>"
				title="Platform"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>	
			<tbl:columndef 
				id="variant"
				property="variant.name"
				datatype="string"
				title="Variant"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>				
			<%
			Enumeration<String, String> rawEnumeration = new Enumeration<String, String>();
			for (RawDataType rdt : RawDataTypes.getRawDataTypes())
			{
				rawEnumeration.add(rdt.getId(), HTML.encodeTags(rdt.getName()));
			}
			rawEnumeration.sortValues();
			%>
			<tbl:columndef 
				id="rawDataType"
				property="rawDataType"
				datatype="string"
				enumeration="<%=rawEnumeration%>"
				title="Raw data type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="arrayNum"
				property="arrayNum"
				datatype="int"
				title="Array index"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="hasData"
				property="hasData"
				datatype="boolean"
				title="Has data"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="spots"
				property="spots"
				datatype="int"
				title="Db spots"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="numFileSpots"
				property="numFileSpots"
				datatype="int"
				title="File spots"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>			
			<tbl:columndef 
				id="bytes"
				property="bytes"
				datatype="long"
				title="Bytes"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="scan"
				property="scan.name"
				datatype="string"
				title="Scan"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="software"
				property="software.name"
				datatype="string"
				title="Software"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="protocol"
				property="protocol.name"
				datatype="string"
				title="Protocol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="arrayDesign"
				property="arrayDesign.name"
				datatype="string"
				title="Array design"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="plugin"
				property="job.pluginDefinition.name"
				datatype="string"
				title="Plugin"
				sortable="true"
				filterable="true"
				exportable="true"
				tooltip="The plug-in that was used to import raw data"
			/>
			<tbl:columndef 
				id="configuration"
				property="job.pluginConfiguration.name"
				datatype="string"
				title="Configuration"
				sortable="true"
				filterable="true"
				exportable="true" 
				tooltip="The configuration/file format that was used to import raw data"
			/>
			<tbl:columndef 
				id="importdate"
				property="job.ended"
				datatype="date"
				title="Import date"
				sortable="true"
				filterable="true"
				exportable="true" 
				tooltip="The date and time of the raw data import"
				formatter="<%=dateTimeFormatter%>"
			/>
			<tbl:columndef
				id="experiments"
				title="Experiments"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<%
			for (AnnotationType at : annotationTypes)
			{
				Enumeration<String, String> annotationEnum = null;
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = HTML.encodeTags(value.toString());
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%="at"+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+" [A]"%>" 
					property="<%="#"+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					sortable="false" 
					filterable="true" 
					exportable="true"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef 
				id="sharedTo" 
				title="Shared to"
			/>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					disabled="<%=createPermission ? false : true%>" 
					image="<%=createPermission ? "new.gif" : "new_disabled.gif"%>" 
					onclick="newItem()" 
					title="New&hellip;" 
					tooltip="<%=createPermission ? "Create new raw bioassay" : "You do not have permission to create raw bioassays"%>" 
				/>
				<tbl:button 
					image="delete.gif"
					onclick="deleteItems()" 
					title="Delete" 
					tooltip="Delete the selected items" 
				/>
				<tbl:button 
					image="restore.gif"
					onclick="restoreItems()" 
					title="Restore" 
					tooltip="Restore the selected (deleted) items"
				/>
				<tbl:button 
					image="share.gif"
					onclick="shareItems()" 
					title="Share&hellip;" 
					tooltip="Share the selected items"
				/>
				<tbl:button 
					image="take_ownership.png"
					onclick="takeOwnership()" 
					title="Take ownership&hellip;"
					tooltip="Take ownership of the selected items"
				/>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button
					image="add.png"
					onclick="newExperiment()"
					title="New experiment&hellip;"
					tooltip="Create a new experiment from the selected raw bioassays"
					visible="<%=sc.hasPermission(Permission.CREATE, Item.EXPERIMENT)%>"
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=rawBioAssays == null ? 0 : rawBioAssays.getTotalCount()%>" 
				visible="<%=mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>

				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
					
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (rawBioAssays != null)
					{						
						while (rawBioAssays.hasNext())
						{
							RawBioAssay item = rawBioAssays.next();
							Job job = null;
							try
							{
								job = item.getJob();
							}
							catch (Throwable t)
							{}
							RawDataType rdt = item.getRawDataType();
							int itemId = item.getId();
							String openSharePopup = "shareItem("+itemId+")";
							String deletePermanently = "deleteItemPermanently("+itemId+")";
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = HTML.encodeTags(item.getName());
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="<%=deletePermission ? "deleted.gif" : "deleted_disabled.gif"%>"
										onclick="<%=deletePermission ? deletePermanently : null%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon 
										image="<%=sharePermission ? "shared.gif" : "shared_disabled.gif"%>" 
										onclick="<%=sharePermission ? openSharePopup : null%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=item.isShared()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)" 
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="spots"><%=item.getNumDbSpots()%></tbl:cell>
								<tbl:cell column="numFileSpots"><%=item.getNumFileSpots()%></tbl:cell>
								<tbl:cell column="bytes"><%=Values.formatBytes(item.getBytes())%></tbl:cell>
								<tbl:cell column="platform"
									><base:propertyvalue 
										item="<%=item%>" 
										property="platform"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="variant"
									><base:propertyvalue 
										item="<%=item%>" 
										property="variant"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>								
								<tbl:cell column="rawDataType"><%=HTML.encodeTags(rdt.getName())%></tbl:cell>
								<tbl:cell column="arrayNum"><%=item.getArrayNum()%></tbl:cell>
								<tbl:cell column="hasData"><%=item.hasData()%></tbl:cell>
								<tbl:cell column="scan"
									><base:propertyvalue 
										item="<%=item%>" 
										property="scan"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="software"
									><base:propertyvalue 
										item="<%=item%>" 
										property="software"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="protocol"
									><base:propertyvalue 
										item="<%=item%>" 
										property="protocol"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="arrayDesign"
									><base:propertyvalue 
										item="<%=item%>" 
										property="arrayDesign"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="plugin">
									<base:propertyvalue 
										item="<%=item%>"
										property="job.pluginDefinition" 
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
										/>
								</tbl:cell>
								<tbl:cell column="configuration">
									<base:propertyvalue 
										item="<%=item%>"
										property="job.pluginConfiguration" 
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/>
								</tbl:cell>
								<tbl:cell 
									column="importdate" 
									value="<%=job == null ? null : job.getEnded() %>" 
								/>
								<tbl:cell column="experiments">
									<%
									experimentQuery.setParameter("rawBioAssay", itemId, Type.INT);
									try
									{
										String separator = "";
										for (Experiment e : experimentQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, e, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(e.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<%
								AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
								for (AnnotationType at : annotationTypes)
								{
									%>
									<tbl:cell column="<%="at"+at.getId()%>">
										<%
										List<?> values = as == null || !as.hasAnnotation(at) ? null : as.getAnnotation(at).getValues();
										%>
										<%=values == null || values.size() == 0 ? "" : HTML.encodeTags(Values.getString(values, ", ", true))%>
									</tbl:cell>
									<%
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										Nameable n = sharees.next();
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(n.getName()));
										}
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
							</tbl:row>
							<%
							}
						}
					%>
					</tbl:rows>
			</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=rawBioAssays == null || rawBioAssays.getTotalCount() == 0 ? "No raw bioassays were found" : "No raw bioassays on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=rawBioAssays == null ? 0 : rawBioAssays.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		<base:buttongroup align="center" clazz="fixedatbottom">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		<br><br><br>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (rawBioAssays != null) rawBioAssays.close();
	if (dc != null) dc.close();
}
%>
