<%-- $Id: edit_scan.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Gregory Vincic
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Scan"
	import="net.sf.basedb.core.Hybridization"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.HardwareType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.SCAN;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Scan scan = null;
	String name = null;
	
	boolean readCurrentHybridization = true;
	Hybridization currentHybridization = null;
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;	
	Protocol defaultProtocol = null;
	boolean readCurrentScanner = true;
	Hardware currentScanner = null;
	Hardware defaultScanner = null;

	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL);
	List<Hardware> recentScanners = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE);
	List<Hybridization> recentHybridizations = (List<Hybridization>)cc.getRecent(dc, Item.HYBRIDIZATION);

	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		try
		{
			defaultProtocol = (Protocol)activeProject.getDefaultItem(dc, Project.Default.SCANNING_PROTOCOL);			
		}
		catch (PermissionDeniedException pdex)
		{
			defaultProtocol = null;
		}
		try
		{
			defaultScanner = (Hardware)activeProject.getDefaultItem(dc, Project.Default.SCANNER_HARDWARE);			
		}
		catch (PermissionDeniedException pdex)
		{
 			defaultScanner = null;
		}
	}
	if (itemId == 0)
	{
		title = "Create scan";
		cc.removeObject("item");
		if (cc.getPropertyFilter("protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("protocol.name"));
		}
		if (cc.getPropertyFilter("scanner.name") != null)
		{
			currentScanner = Base.getFirstMatching(dc, Hardware.getQuery(), "name", cc.getPropertyFilter("scanner.name"));
		}
		int hybridizationId = Values.getInt(request.getParameter("hybridization_id"));
		if (hybridizationId != 0)
		{
			currentHybridization = Hybridization.getById(dc, hybridizationId);
		}
		else if (cc.getPropertyFilter("hybridization.name") != null)
		{
			currentHybridization = Base.getFirstMatching(dc, Hybridization.getQuery(), "name", cc.getPropertyFilter("hybridization.name"));
		}
			
		if (currentHybridization != null)
		{
			name = currentHybridization.getName() + ".s" + (currentHybridization.countScans() + 1);
		}
		else
		{
			name = Values.getString(cc.getPropertyValue("name"), "New scan");
		}
	}
	else
	{
		scan = Scan.getById(dc, itemId);
		scan.checkPermission(Permission.WRITE);
		name = scan.getName();
		cc.setObject("item", scan);
		title = "Edit scan -- " + HTML.encodeTags(scan.getName());
		try
		{
			currentHybridization = scan.getHybridization();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentHybridization = false;
		}
		try
		{
			currentProtocol = scan.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentScanner = scan.getScanner();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentScanner = false;
		}
	}

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Scan" tab
		function validateScan()
		{
			var frm = document.forms['scan'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			var hybId = frm.hybridization_id.length == 0 ? 
				0 : frm.hybridization_id[frm.hybridization_id.selectedIndex].value;
			if (hybId == 0)
			{
				alert("You must select a hybridization");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['scan'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=scan == null ? 0 : scan.getId()%>, getProtocolId());
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		
		function getProtocolId()
		{
			var frm = document.forms['scan'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}

		function getParents()
		{
			var frm = document.forms['scan'];
			var parents = new Array();
			var hybridizationId = Math.abs(parseInt(frm.hybridization_id[frm.hybridization_id.selectedIndex].value));
			if (hybridizationId > 0) parents[parents.length] = 'HYBRIDIZATION:'+hybridizationId;
			return parents;
		}

		function selectProtocolOnClick()
		{
			var frm = document.forms['scan'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&filter:INT:protocolType=<%=SystemItems.getId(ProtocolType.SCANNING)%>';
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['scan'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}

		function selectScannerOnClick()
		{
			var frm = document.forms['scan'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setScannerCallback';
			if (frm.scanner_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.scanner_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&filter:INT:hardwareType=<%=SystemItems.getId(HardwareType.SCANNER)%>';
			Main.openPopup(url, 'SelectScanner', 1000, 700);
		}
		function setScannerCallback(id, name)
		{
			var frm = document.forms['scan'];
			var list = frm.scanner_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function hybridizationOnChange()
		{
			parentsChanged = true;
		}

		function selectHybridizationOnClick()
		{
			var frm = document.forms['scan'];
			var url = '../hybridizations/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setHybridizationCallback';
			if (frm.hybridization_id.length > 0) 
			{
				var id = Math.abs(parseInt(frm.hybridization_id[0].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectHybridization', 1000, 700);
		}
		function setHybridizationCallback(id, name)
		{
			var frm = document.forms['scan'];
			var list = frm.hybridization_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			parentsChanged = true;
		}

		function init()
		{
			<%
			if (scan == null)
			{
				%>
				var frm = document.forms['scan'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="scan" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=scan != null%>" switch="switchTab">
		<t:tab id="info" title="Scan" validate="validateScan()" helpid="scan.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					size="40" maxlength="<%=Scan.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Hybridization</td>
				<td>
					<base:select 
						id="hybridization_id"
						clazz="selectionlist"
						required="true"
						current="<%=currentHybridization%>"
						denied="<%=!readCurrentHybridization%>"
						recent="<%=recentHybridizations%>"
						newitem="<%=scan == null%>"
						onselect="selectHybridizationOnClick()"
						onchange="hybridizationOnChange()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Scanner</td>
				<td>
					<base:select 
						id="scanner_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentScanner%>"
						denied="<%=!readCurrentScanner%>"
						recent="<%=recentScanners%>"
						defaultitem="<%=defaultScanner%>"
						newitem="<%=scan == null%>"
						onselect="selectScannerOnClick()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitem="<%=defaultProtocol%>"
						newitem="<%=scan == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(scan == null ? cc.getPropertyValue("description") : scan.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'scan', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" 
			helpid="annotations.edit" tooltip="Enter values for annotations and protocol parameters">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
